package org.jboss.envers.demo.seam.wiki;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.In;
import org.jboss.envers.VersionsReader;
import org.jboss.envers.query.VersionsRestrictions;
import org.jboss.envers.query.RevisionProperty;

import java.util.List;
import java.util.ArrayList;

/**
 * @author Adam Warski (adam at warski dot org)
 */
@Name("historyReader")
public class HistoryReader {
    @In
    private VersionsReader versionsReader;

    @In("#{wikiPageHome.id}")
    private Integer wikiPageId;

    private List<HistoryEntry> history;

    public List<HistoryEntry> getHistory() {
        if (history == null) {
            history = new ArrayList<HistoryEntry>();

            List versions = versionsReader.createQuery().forRevisionsOfEntity(WikiPage.class, false, false)
                    .add(VersionsRestrictions.idEq(wikiPageId))
                    .addOrder(RevisionProperty.desc())
                    .getResultList();

            for (Object versionDataObject : versions) {
                Object[] versionData = (Object[]) versionDataObject;
                history.add(new HistoryEntry((WikiPage) versionData[0], (WikiLog) versionData[1]));
            }
        }

        return history;
    }
}
