package org.jboss.envers.demo.seam.wiki;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.In;
import org.jboss.seam.ScopeType;

import java.util.ArrayList;

/**
 * @author Adam Warski (adam at warski dot org)
 */
@Name("wikiEdit")
@Scope(ScopeType.CONVERSATION)
public class WikiEdit {
    @In("#{wikiPageHome.instance}")
    private WikiPage wikiPage;

    private String newLink;

    public String getNewLink() {
        return newLink;
    }

    public void setNewLink(String newLink) {
        this.newLink = newLink;
    }

    public void addLink() {
        if (wikiPage.getLinks() == null) {
            wikiPage.setLinks(new ArrayList<String>());
        }
        
        wikiPage.getLinks().add(newLink);

        newLink = null;
    }

    public void deleteLink(String link) {
        wikiPage.getLinks().remove(link);
    }
}
