package org.jboss.shotoku.web;

import com.sun.facelets.impl.ResourceResolver;

import javax.faces.context.FacesContext;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class FileResourceResolver implements ResourceResolver {
    private String sourceBasePath;

    public String getSourceBasePath() {
        if (sourceBasePath == null) {
            sourceBasePath = FacesContext.getCurrentInstance().getExternalContext()
                    .getInitParameter("sourceBasePath");
        }

        return sourceBasePath;
    }

    public URL resolveUrl(String s) {
        try {
            return new URL("file", "", getSourceBasePath() + s);
        } catch (MalformedURLException e) {
            e.printStackTrace();
            return null;
        }
    }
}