package org.jboss.envers.demo.seam.persons;

import org.jboss.envers.Versioned;

import javax.persistence.*;
import java.util.Date;

/**
 * @author Adam Warski (adam at warski dot org)
 */
@Entity
@Versioned
public class Registration {
    @Id
    @GeneratedValue
    private Integer id;

    @ManyToOne(optional = false)
    private Address address;

    @OneToOne(cascade = CascadeType.ALL, optional = false)
    private Person person;

    @Temporal(TemporalType.DATE)
    private Date registrationDate;

    @Temporal(TemporalType.DATE)
    private Date actualDate;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

    public Person getPerson() {
        return person;
    }

    public void setPerson(Person person) {
        this.person = person;
    }

    public Date getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(Date registrationDate) {
        this.registrationDate = registrationDate;
    }

    public Date getActualDate() {
        return actualDate;
    }

    public void setActualDate(Date actualDate) {
        this.actualDate = actualDate;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Registration)) return false;

        Registration that = (Registration) o;

        if (actualDate != null ? !actualDate.equals(that.actualDate) : that.actualDate != null) return false;
        if (id != null ? !id.equals(that.id) : that.id != null) return false;
        if (registrationDate != null ? !registrationDate.equals(that.registrationDate) : that.registrationDate != null)
            return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = (id != null ? id.hashCode() : 0);
        result = 31 * result + (registrationDate != null ? registrationDate.hashCode() : 0);
        result = 31 * result + (actualDate != null ? actualDate.hashCode() : 0);
        return result;
    }
}
