package org.jboss.envers.demo.seam.wiki;

import org.jboss.envers.RevisionEntity;
import org.jboss.envers.RevisionNumber;
import org.jboss.envers.RevisionTimestamp;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.GeneratedValue;
import javax.persistence.Transient;
import java.util.Date;

/**
 * @author Adam Warski (adam at warski dot org)
 */
@Entity
@RevisionEntity(WikiRevisionListener.class)
public class WikiLog {
    @Id
    @GeneratedValue
    @RevisionNumber
    private int id;

    @RevisionTimestamp
    private long timestamp;

    private String author;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    @Transient
    public Date getDate() {
        return new Date(getTimestamp());
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof WikiLog)) return false;

        WikiLog wikiLog = (WikiLog) o;

        if (id != wikiLog.id) return false;
        if (timestamp != wikiLog.timestamp) return false;
        if (author != null ? !author.equals(wikiLog.author) : wikiLog.author != null) return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = id;
        result = 31 * result + (int) (timestamp ^ (timestamp >>> 32));
        result = 31 * result + (author != null ? author.hashCode() : 0);
        return result;
    }
}
