package org.jboss.envers.demo.seam.wiki;

import org.jboss.envers.Versioned;
import org.hibernate.annotations.CollectionOfElements;
import org.hibernate.annotations.IndexColumn;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.GeneratedValue;
import java.util.List;

/**
 * @author Adam Warski (adam at warski dot org)
 */
@Entity
@Versioned
public class WikiPage {
    @Id
    @GeneratedValue
    private int id;

    private String title;

    private String content;

    @CollectionOfElements
    @IndexColumn(name = "ind")
    private List<String> links;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public List<String> getLinks() {
        return links;
    }

    public void setLinks(List<String> links) {
        this.links = links;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof WikiPage)) return false;

        WikiPage wikiPage = (WikiPage) o;

        if (id != wikiPage.id) return false;
        if (title != null ? !title.equals(wikiPage.title) : wikiPage.title != null) return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = id;
        result = 31 * result + (title != null ? title.hashCode() : 0);
        return result;
    }
}
